﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using static Spcidevdll;

// 此例程是控制采集卡数字输入单点读取
// 此例程适用型号：
// PCI-1132
// PCI-1316
// PCI-225x
// PCI-3xxx
// PCI-5xxx

namespace di_one_point
{
    class Program
    {
        static int Main(string[] args)
        {
            int rst;
            int DevIndex = 0;
            uint DiValue = 0;

            // 打开设备
            rst = OpenDevice(DevIndex);
            if (rst < 0) { return rst; }

            // 设置数字 I/O 方向
            // 由于 PCI-225x/3000/5000 的数字 I/O 可以设置为输入或者输出
            // 此处全部设置为输入
            // 其他数字 I/O 不支持设置的型号可以不用设置
            rst = SetDioDir(DevIndex, 0xffffffff);
            if (rst < 0) { return rst; }

            // 设置 Di 灵敏度
            rst = SetDiSensitivity(DevIndex, 20000);
            if (rst < 0) { return rst; }

            // 读取 Di 状态
            rst = GetDiStatus(DevIndex, 0, ref DiValue);
            if (rst < 0) { return rst; }

            Console.WriteLine("GetDiStatus Success. DiValue = 0x{0:X}", DiValue);

            // 关闭设备
            rst = CloseDevice(DevIndex);

            return rst;
        }
    }
}
