﻿using System;
using System.Runtime.InteropServices;

public class Spcidevdll
{
    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int OpenDevice(int DevIndex);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int CloseDevice(int DevIndex);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int GetDeviceModel(int DevIndex, ref uint Model);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int GetDeviceSN(int DevIndex, ref uint SN);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ReadDevice(int DevIndex, uint OffsetAddress, ref uint Value);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int WriteDevice(int DevIndex, uint OffsetAddress, uint Value);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int GetDriverFifoUsedw(int DevIndex, ref uint DriverFifoUsedw);

    //--------------------------------------------------------------------------
    // analog input function
    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int AiReady(int DevIndex, uint ReadyOrNot);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAiConnectType(int DevIndex, uint AiConnectType);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAiChannelSellect(int DevIndex, uint AiChannelSellect);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAiSampleMode(int DevIndex, uint AiSampleMode);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAiRange(int DevIndex, uint AiRange, uint AiChannel);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAiSamplePeriod(int DevIndex, uint AiSamplePeriod);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAiOneShotCount(int DevIndex, uint AiOneShotCount);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAiTrigSource(int DevIndex, uint AiTrigSource);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int GetAiOnePoint(int DevIndex, uint AiChannel, ref float AiValue);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int GetAiData(int DevIndex, uint Points, float[] AiValue, ref uint AiFifoUsdw, uint Timeout);

    //--------------------------------------------------------------------------
    // analog output function
    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int AoReady(int DevIndex, uint AoChannel, uint ReadyOrNot);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAoMode(int DevIndex, uint AoChannel, uint AoMode);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAoSamplePeriod(int DevIndex, uint AoChannel, uint AoSamplePeriod);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAoNCycleCount(int DevIndex, uint AoChannel, uint AoNCycleCount);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAoTrigSource(int DevIndex, uint AoChannel, uint AoTrigSource);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAoValue(int DevIndex, uint AoChannel, float AoValue);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAoPowerOnValue(int DevIndex, uint AoChannel, float AoPowerOnValue);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAoFifo(int DevIndex, uint AoChannel, float AoWaveData);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ClearAoFifo(int DevIndex, uint AoChannel);

    //--------------------------------------------------------------------------
    // digital input function
    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int DiReady(int DevIndex, uint ReadyOrNot);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiSampleMode(int DevIndex, uint DiSampleMode);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiSamplePeriod(int DevIndex, uint DiSamplePeriod);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiOneShotCount(int DevIndex, uint DiOneShotCount);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiTrigSource(int DevIndex, uint DiTrigSource);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int GetDiStatus(int DevIndex, uint Part, ref uint DiValue);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int GetDiData(int DevIndex, uint Points, uint[] DiValue, ref uint DiFifoUsdw, uint Timeout);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiIntLevel(int DevIndex, uint DiIntLevel);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiIntSource(int DevIndex, uint DiIntSource);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiIntEn(int DevIndex, uint DiIntEn);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiSensitivity(int DevIndex, uint DiSensitivity);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiCountEn(int DevIndex, uint DiCountEn);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiCountEdge(int DevIndex, uint DiCountEdge);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int GetDiCountValue(int DevIndex, uint DiChan, ref uint DiCountValue);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ClearDiCountValue(int DevIndex, uint DiChan);

    //--------------------------------------------------------------------------
    // digital output function
    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int DoReady(int DevIndex, uint ReadyOrNot);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDoMode(int DevIndex, uint DoMode);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDoSamplePeriod(int DevIndex, uint DoSamplePeriod);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDoNCycleCount(int DevIndex, uint DoNCycleCount);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDoTrigSource(int DevIndex, uint DoTrigSource);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDoValue(int DevIndex, uint DoValue);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDoPowerOnValue(int DevIndex, uint DoPowerOnValue);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDoFifo(int DevIndex, uint DoWaveData);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ClearDoFifo(int DevIndex);

    //--------------------------------------------------------------------------
    // trig system function
    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAiSoftTrig(int DevIndex);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDiSoftTrig(int DevIndex);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetAoSoftTrig(int DevIndex, uint AoChannel);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDoSoftTrig(int DevIndex);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetExtTrigInEdge(int DevIndex, uint TrigEdge);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ClearAiSoftTrig(int DevIndex);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ClearDiSoftTrig(int DevIndex);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ClearAoSoftTrig(int DevIndex, uint AoChannel);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ClearDoSoftTrig(int DevIndex);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int ClearExtTrig(int DevIndex);

    //--------------------------------------------------------------------------
    // sync function
    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetClockSource(int DevIndex, uint ClockSource);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetSyncClkDir(int DevIndex, uint Direction);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetUserIsr(int DevIndex, IntPtr fun);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDioDir(int DevIndex, uint DioDir);

    [DllImport("spcidev.dll", CallingConvention = CallingConvention.Cdecl)]
    public static extern int SetDioDirDefault(int DevIndex, uint DioDirDefault);
}
