﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using static Spcidevdll;

// 此例程设置数字I/O通道上电时的默认方向和 Do 上电默认值。
// 此例程适用型号：
// PCI-1232
// PCI-1316
// PCI-225x
// PCI-3xxx
// PCI-5xxx

namespace dio_default_setting
{
    class Program
    {
        static int Main(string[] args)
        {
            int rst;
            int DevIndex = 0;

            // 打开设备
            rst = OpenDevice(DevIndex);
            if (rst < 0) { return rst; }

            // 设置数字 I/O 上电默认方向
            // 参数每一 bit 对应一个 数字 I/O
            // 此处全部设置为输出
            rst = SetDioDirDefault(DevIndex, 0x00000000);
            if (rst < 0) { return rst; }

            // 设置 Do 上电默认值
            // 参数每一 bit 对应一个 Do
            // 此处全部设置为 0
            rst = SetDoPowerOnValue(DevIndex, 0x00000000);
            if (rst < 0) { return rst; }

            Console.WriteLine("Success.");

            // 关闭设备
            rst = CloseDevice(DevIndex);

            return rst;
        }
    }
}
