﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using static Spcidevdll;

// 此例程对采集卡数字输出通道的状态进行单次设置。
// 此例程适用型号：
// PCI-1232
// PCI-1316
// PCI-225x
// PCI-3xxx

namespace do_one_point
{
    class Program
    {
        static int Main(string[] args)
        {
            int rst;
            int DevIndex = 0;

            // 打开设备
            rst = OpenDevice(DevIndex);
            if (rst < 0) { return rst; }

            // 设置数字 I/O 方向
            // 此处将所有的数字 I/O 通道设置为输出
            // 由于 PCI-225x/3000/5000 的数字 I/O 可以设置为输入或者输出
            // 此处全部设置为输入
            // 其他数字 I/O 不支持设置的型号可以不用设置
            rst = SetDioDir(DevIndex, 0x00000000);
            if (rst < 0) { return rst; }

            // 设置 Do 住处状态
            // 此处将所有的 Do 通道输出为高电平
            rst = SetDoValue(DevIndex, 0xffffffff);
            if (rst < 0) { return rst; }

            Console.WriteLine("Success.");

            // 关闭设备
            rst = CloseDevice(DevIndex);

            return rst;
        }
    }
}
